<?php
	require_once("inclueds.php");
	
	class ResReadMain
	{
		function ResReadMain()
		{

		}
		
		function ExecutePHPMODE($bbs, $key, $option)
		{
			$errmsg = ErrMessage::getInstance();
			$ret = BBSList::getInstance()->Init();
			
			if(ErrInfo::IsErr($ret))
			{
				return $ret;
			}

			if(!in_array($bbs, Util::getBBSList()))
			{
				 return Logging::generrinfo($this,
					__FUNCTION__ , __LINE__ , 
					$errmsg->bbs_notfound, ErrMsgID::get()->URLFORMAT);
			}
			
			if(!file_exists("../{$bbs}/dat/{$key}.dat"))
			{
				return Logging::generrinfo($this,
					__FUNCTION__ , __LINE__ , 
					$errmsg->threadkey_invalid, 
					ErrMsgID::get()->THREAD_NOT_FOUND );
			}			
			
			$hostinfo = HostInfo::getInstance();
			$hostinfo->Init($_SERVER['REMOTE_ADDR'], $_SERVER['HTTP_USER_AGENT']);
			
			$reader = new ResReader();
			
			$ret = $reader->Init($key);
			
			if(ErrInfo::IsErr($ret))
			{
				return $ret;
			}
			
			$c_name = $_COOKIE[FROM];
			$c_mail = $_COOKIE[mail];
			
			$c_name = @mb_convert_encoding($c_name, "SJIS", "UTF-8");
			$c_mail = @mb_convert_encoding($c_mail, "SJIS", "UTF-8");
		
			$reslines = $reader->getResLines($option);
			
			if(ErrInfo::IsErr($reslines))
			{
				return $reslines;
			}

			$fields = explode("<>", $reader->datdata->data[0]);
			
			if(count($fields) < 5)
			{
				$subject = 'X^Cs';
			}
			else
			{
				list(,,,,$subject) = $fields;
			}
			
			$result = ResReader::ParseOption($option);

			if(ErrInfo::IsErr($result))
			{
				return $result;
			}
			
			$optinfo = $result;

			$pastnums = ResReader::getPastNums($optinfo["st"], $optinfo["end"]);
			$nextnums = ResReader::getNextNums($optinfo["st"], $optinfo["end"]);
			
			$past = (($optinfo["st"] - 100) > 1) ? ($optinfo["st"] - 100) : 1;
			$pastend = $past + 100;
			$nextend = $optinfo["st"] + 100;
			$speed = $reader->datdata->getRowCount() / ((int)(time() / 60) - (int)($key / 60)) * 60 * 24; 
			$size = strlen(file_get_contents("../{$bbs}/dat/{$key}.dat"));
			
			$html = <<<EOM
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
	<meta name="Author" content="">
	<meta content="no-cache" http-equiv="Pragma">
	<meta http-equiv="Content-Style-Type" content="text/css">
	<meta http-equiv="Content-Script-Type" content="text/javascript">
	<title></title>
	<link rel="stylesheet" type="text/css" href="../../../ajax/read.css" media="screen">

</head>
<body>
<div id="header">
<span class="headlist">
<a href="">yBBS2ch</a>z</span>
<span style='float:left;'><a href="#footer"></a>
<a href="../../../../{$bbs}/index.html">fɖ߂</a> <a href="../{$key}/">S</a> <a href="../{$key}/|50">ŐV50</a>
</span>
<br style='clear:both;'>
</div>
<h1 id="subject">{$subject}</h1>
<dl id=resbodys>
{$reslines}
</dl>


<font color="red" face="Arial"><b id="size">{$size}</b></font> <span id="speed" title="͈̃X̖ڈłB(=XXĂ̕~60~24)" style="font-family:Arial;color:green;"><strong>Speed:{$speed}</strong></span>&nbsp;&nbsp;

<hr id="footer"><a href="#header"></a> <a href="../../../../{$bbs}/index.html">fɖ߂</a> <a href="../{$key}/">S</a> <a href="../{$key}/{$past}-{$pastend}">O100</a> <a href="../{$key}/{$optinfo["st"]}-{$nextend}">100</a> <a href="../{$key}/|50">ŐV50</a>
<a href="">VX\</a>
<hr size="1" id="footer">
<form action="../../../../test/bbs.php?guid=On" method="post" utn="utn">
<input type="submit" value="ށyShift+Enterz">
 OF<input type="text" name="FROM" size="19" value=""> 
 E-mail(<font size="1">{$mail}</font>)F<input type="text" size="30" name="mail" value=""><br>
 <textarea name="MESSAGE" id="message" rows="6" cols="84" erap="off"></textarea><br>
 <input type="hidden" name="key" value="{$key}">
 <input type="hidden" name="bbs" value="{$bbs}">
 <input type="hidden" name="time" value="">
 <input type="hidden" name="suka" value="">
 </form><br>
</span><br style='clear:both;'>
</body>
</html>
EOM;
			 echo $html;
			 
			 return true;
		 }
		 
		 function Execute()
		 {
			 $pathinfo = explode("/", $_SERVER["PATH_INFO"]);
			 $errmsg = ErrMessage::getInstance();
			 ErrMsgGetter::getInstance();

			 if(count($pathinfo) < 3)
			 {
				 return Logging::generrinfo($this,
					 __FUNCTION__ , __LINE__ , 
					 $errmsg->bbskey_null, ErrMsgID::get()->URLFORMAT);
			 }
			 
			 $bbs = $pathinfo[1];
			 $key = $pathinfo[2];

			 $ret = SettingInfo::getInstance()->Init($bbs, $key);

			 if($ret !== true)
			 {
				 return $ret;
			 }
			 
			 $setting = SettingInfo::getInstance();
			 
			 $php_mode = (($setting->BBS_READ_SCRIPT != null) && 
				 $setting->BBS_READ_SCRIPT == "php") ? true : false;
			 
			 if((count($pathinfo) <= 3) && ($php_mode))
			 {
				  return Logging::generrinfo($this,
					 __FUNCTION__ , __LINE__ , 
					 $errmsg->urlformat, ErrMsgID::get()->URLFORMAT);
			 }
			 
			 $ret = Logging::getInstance()->Init();
			 
			 if(ErrInfo::IsErr($ret))
			 {
				 return $ret;
			 }
			 
			 $option = $pathinfo[3] ;

			 if($php_mode)
			 {
				 return $this->ExecutePHPMODE($bbs, $key, $option);
			 }
			 
			 $hostinfo = HostInfo::getInstance();
			 $hostinfo->Init($_SERVER['REMOTE_ADDR'], $_SERVER['HTTP_USER_AGENT']);
			 $baseurl = Util::getBaseUrl();
			 
			 if($hostinfo->carrier === null)
			 {
				 Util::Redirect("{$baseurl}/navigate.html");
			 }
			 else
			 {
				 $link = "{$baseurl}/mread.php/{$bbs}/{$key}/|10";
				 $html = <<<EOM
<html><head><title>{$subject}</title>
<meta http-equiv=Content-Type content="text/html;charset=Shift-JIS">
</head><!--nobanner-->
<html><body>
<a href="{$link}">{$link}</a>
</body></html>
				 
EOM;
				 echo $html;
			 }
		 }

		 function OutPutErrHtml(&$errinfo)
		 {
			 $setting = SettingInfo::getInstance();
			 
			 $sysmsg = "";
			 if($errinfo->usrmsgid == ErrMsgID::get()->SYSERR)
			 {
				 $sysmsg = "{$errinfo->sysmsg}<br>";
			 }
			 
			 $html = <<<EOM
<html><head><title>{$subject}</title>
<meta http-equiv=Content-Type content="text/html;charset=Shift-JIS">
</head><!--nobanner-->
<html><body>
<b>{$errinfo->usrmsg}</b>{$sysmsg}
</body></html>
				 
EOM;
			 echo $html;
		 }
	 }
	 
	 $reader = new ResReadMain();
	 
	 $ret = $reader->Execute();

	 if(ErrInfo::IsErr($ret))
	 {
		 ResReadMain::OutPutErrHtml($ret);
	 }
?>
